{#-

    Template for generating informational summary reports about Mentat system
    performance in HTML format.

    Author: Jan Mach <jan.mach@cesnet.cz>

#}
{%- import '_labels.j2' as report_labels -%}

{%- macro render_stats_table(chstats, chsection) %}
    {%- if chsection in chstats %}
        {%- set chdata  = chstats[chsection] %}
        {%- set chkeys  = sort_keys_desc(chstats[chsection]) %}
        {%- set chsum   = sum_dict(chstats[chsection]) %}
        {%- set tdstyle = 'border-width: 1px; padding-left: 3px; padding-right: 3px;' %}
<table border="1" cellspacing="0" style="border-width: 1px; border-collapse: collapse;">
        {%- for chitemkey in chkeys %}
    <tr>
        <td style="{{ tdstyle }} text-align: right;">
            {{ '{:>2d}'.format(loop.index) }}
        </td>
        <td style="{{ tdstyle }}">
            {{ '{:60s}'.format(format_section_key(chsection, chitemkey)) }}
        </td>
        <td style="{{ tdstyle }} text-align: right;">
            {{ '{:>17s}'.format(format_decimal(chdata.get(chitemkey, 0))) }}
        </td>
        <td style="{{ tdstyle }} text-align: right;">
            {{ '{:>6.2f} %'.format(chdata.get(chitemkey, 0)/chsum*100) }}
        </td>
    </tr>
        {%- endfor %}
    <tr>
        <td colspan="2" style="{{ tdstyle }} ">
        </td>
        <td style="{{ tdstyle }} text-align: right;">
            {{ '{:>17s}'.format(format_decimal(chsum)) }}
        </td>
        <td style="{{ tdstyle }} text-align: right;">
            100.00 %
        </td>
    </tr>
</table>
    {%- else %}
<h4>{{ _('No data') }}</h4>
    {%- endif %}
{%- endmacro %}
<h1>{{ title | upper }}</h1>

<hr>

<table border="0" cellspacing="0" style="border-width: 0">
    <tr>
        <td>
            <strong>{{ _('Total number of events:') }}</strong>
        </td>
        <td>
            {{ format_decimal(stats_events.get('count', 0)) }}
        </td>
    </tr>
    <tr>
        <td>
            <strong>{{ _('Number of generated reports:') }}</strong>
        </td>
        <td>
            {{ format_decimal(stats_reports_cnt_all) }} ({{ format_decimal(stats_reports_cnt) }} {{ _('summary') }}, {{ format_decimal(stats_reports_cnt_all - stats_reports_cnt) }} {{ _('extra') }})
        </td>
    </tr>
    <tr>
        <td>
            <strong>{{ _('Number of sent emails:') }}</strong>
        </td>
        <td>
            {{ format_decimal(stats_reports.get('cnt_emails', 0)) }}
        </td>
    </tr>
    <tr>
        <td>
            <strong>{{ _('Number of reported events:') }}</strong>
        </td>
        <td>
            {{ format_decimal(stats_reports.get('cnt_events', 0)) }}
        </td>
    </tr>
    <tr>
        <td>
            <strong>{{ _('Summary for time period:') }}</strong>
        </td>
        <td>
            {{ format_tzdatetime(dt_l) }} - {{ format_tzdatetime(dt_h) }} ({{ format_timedelta(dt_h - dt_l ) }})
        </td>
    </tr>
</table>

<h2>{{ _('Contents') }}</h2>
<ol type="A">
    <li>
        <a href="#section-A">{{ _('Event processing statistics') }}</a>
        <ol type="1">
{%- for chsection in ('ips', 'categories', 'detectors', 'analyzers', 'abuses', 'asns', 'countries') %}
            <li>
                <a href="#section-A-{{ loop.index }}">
                    {{ report_labels.section_label_evt(chsection) }}
                </a>
            </li>
{%- endfor %}
        </ol>
    </li>
    <li>
        <a href="#section-B">{{ _('Event reporting statistics') }}</a>
        <ol type="1">
{%- for chsection in ('emails', 'ips', 'categories', 'detectors', 'analyzers', 'abuses', 'asns', 'countries') %}
            <li>
                <a href="#section-B-{{ loop.index }}">
                    {{ report_labels.section_label_rep(chsection) }}
                </a>
            </li>
{%- endfor %}
        </ol>
    </li>
</ol>

<h2>
    <a name="section-A">A. {{ _('Event processing statistics') }}</a>
</h2>

{%- for chsection in ('ips', 'categories', 'detectors', 'analyzers', 'abuses', 'asns', 'countries') %}
<h3>
    <a name="section-A-{{ loop.index }}">
        {{ 'A.{:d}'.format(loop.index) }} {{ report_labels.section_label_evt(chsection) }}
    </a>
</h3>
{{
    render_stats_table(
        stats_events['stats_overall'],
        chsection
    )
}}
{% endfor %}
<p>
    {{ _('You may also view this summary report online:') }}<br>
    <a href="{{ format_url(additional_vars['url_dashboard_proc'], {'submit': 'Search', 'dt_from': dt_l.isoformat(sep = ' '), 'dt_to': dt_h.isoformat(sep = ' ')}) }}">
        {{ format_url(additional_vars['url_dashboard_proc'], {'submit': 'Search', 'dt_from': dt_l.isoformat(sep = ' '), 'dt_to': dt_h.isoformat(sep = ' ')}) }}
    </a>
</p>

<h2>
    <a name="section-B">B. {{ _('Event reporting statistics') }}</a>
</h2>

{%- for chsection in ('emails', 'ips', 'categories', 'detectors', 'analyzers', 'abuses', 'asns', 'countries') %}
<h3>
    <a name="section-B-{{ loop.index }}">
        {{ 'B.{:d}'.format(loop.index) }} {{ report_labels.section_label_rep(chsection) }}
    </a>
</h3>
{{
    render_stats_table(
        stats_reports,
        chsection
    )
}}
{% endfor %}
<p>
    {{ _('You may also view this summary report online:') }}<br>
    <a href="{{ format_url(additional_vars['url_dashboard_rep'], {'submit': 'Search', 'dt_from': dt_l.isoformat(sep = ' '), 'dt_to': dt_h.isoformat(sep = ' ')}) }}">
        {{ format_url(additional_vars['url_dashboard_rep'], {'submit': 'Search', 'dt_from': dt_l.isoformat(sep = ' '), 'dt_to': dt_h.isoformat(sep = ' ')}) }}
    </a>
</p>

<hr>

<p>
    {{ _('Have a nice day') }}<br>

    <br>

    {{ _('Mentat System') }} (<a href="{{ _('https://mentat.cesnet.cz/en/index') }}">{{ _('https://mentat.cesnet.cz/en/index') }}</a>)<br>
    {{ _('CESNET-CERTS Computer Security Team') }} &lt;<a href="mailto:certs@cesnet.cz">certs@cesnet.cz</a>&gt; (<a href="{{ _('https://csirt.cesnet.cz/en/index') }}">{{ _('https://csirt.cesnet.cz/en/index') }}</a>)<br>
    {{ _('CESNET, z.s.p.o.') }} (<a href="{{ _('http://www.ces.net/') }}">{{ _('http://www.ces.net/') }}</a>)<br>

    <br>
    ---<br>
    <br>
    <strong>{{ _('Timezone:') }}</strong> {{ get_timezone() }}<br>
    <strong>{{ _('Generated at:') }}</strong> {{ format_tzdatetime(dt_c) }}<br>
    <strong>{{ _('Time period:') }}</strong> {{ format_tzdatetime(dt_l) }} - {{ format_tzdatetime(dt_h) }} ({{ format_datetime(dt_l) }} - {{ format_datetime(dt_h) }} UTC)
</p>
